# frozen_string_literal: true

module Dingding
  class Notifier
    class Config
      def initialize
        @http_client = Util::HTTPClient
        @middleware  = %i[
          format_text
          format_link
          format_markdown
          format_action_card
          format_feed_card
        ]
      end

      def http_client client=nil
        return @http_client if client.nil?
        raise ArgumentError, "the http client must respond to ::post" unless client.respond_to?(:post)

        @http_client = client
      end

      def middleware *args
        args.delete_if{|a| a.nil?}
        return [:format_text] if args.empty? || args.nil?
        
        @middleware =
          if args.length == 1 && args.first.is_a?(Array) || args.first.is_a?(Hash)
            args.first
          else
            args
          end
      end
    end
  end
end
