# frozen_string_literal: true

module Dingding
  class Notifier
    class PayloadMiddleware
      class << self
        def registry
          @registry ||= {}
        end

        def register middleware, name
          registry[name] = middleware
        end
      end
    end
  end
end

require_relative "payload_middleware/stack"
require_relative "payload_middleware/base"
require_relative "payload_middleware/format_text"
require_relative "payload_middleware/format_link"
require_relative "payload_middleware/format_markdown"
require_relative "payload_middleware/format_action_card"
require_relative "payload_middleware/format_feed_card"